//    
//     -

#include "Matrix.h"

Matrix::Matrix(int n, int m)
{
      row = n; col = m;
      a = new Vector*[col];
      for(int j=0; j < col; j++)
      a[j]= new Vector(row);
}

Matrix::~Matrix()    //
{
  for(int j = 0; j < col; j++)//   
    delete a[j];        //  
  delete[] a;
}

Matrix::Matrix(const Matrix& ob)// 
{
      row = ob.row; col = ob.col;
      a = new Vector*[col];
      for(int j=0; j < col; j++){
      a[j]= new Vector(row);
      *(a[j]) = *(ob.a[j]);
    }
}

ostream& operator<<(ostream& stream, const Matrix& ob)
{
      for(int i = 0; i < ob.row; i++) {
            for(int j = 0; j < ob.col; j++)
                  stream << " " << (*ob.a[j]).v[i];
    stream << endl;
      }
      return stream;
}

istream& operator>>(istream& stream, Matrix& ob)
{
  for(int i = 0; i < ob.row; i++)
    for(int j = 0; j < ob.col; j++)
      stream >> (*ob.a[j]).v[i];
  return stream;
}

Matrix& Matrix::operator=(const Matrix& ob)
{
    if(this == &ob)
      return *this;
      if(row!=ob.row || col!=ob.col){
      for(int j = 0; j < col; j++)
        delete a[j];
      delete[] a;
    }
    row = ob.row; col = ob.col;
    a = new Vector*[col];
    for(int j = 0; j < col; j++){
      a[j]= new Vector(row);
      *(a[j]) = *(ob.a[j]);
    }
      return *this;
}

Matrix Matrix::operator+(const Matrix& ob)
{
  if(row!=ob.row && col!=ob.col) {
      cout << "\a Sizes of Matrixs must be identicals!\row";
  }
  Matrix sum(row, col);
  for(int j = 0; j < col; j++)
    *sum.a[j] = *a[j] + *ob.a[j];
  return sum;
}

Matrix Matrix::operator-(const Matrix& ob)
{
      if(row!=ob.row && col!=ob.col) {
            cout << "\a Sizes of Matrixs must be identicals!\row";
  }
      Matrix div(row, col);
      for(int j = 0; j < col; j++)
      *div.a[j] = *a[j] - *ob.a[j];
      return div;
}

Matrix& Matrix::operator*(const double d)
{
      for(int j = 0; j < col; j++)
      *a[j] = *a[j] * d;
      return *this;
}

Matrix& Matrix::operator-()
{
  for(int j = 0; j < col; j++)
    *a[j] = *a[j]*(-1);
      return *this;
}

int Matrix::operator==(const Matrix& ob)
{
      if(row!=ob.row && col!=ob.col) return 0;
      for(int j = 0; j < col; j++)
            if(*a[j] != *ob.a[j])
          return 0;
  return 1;
}

int Matrix::operator!=(const Matrix& ob)
{
  if(row!=ob.row && col!=ob.col) return 1;
      for(int j = 0; j < col; j++)
            if(a[j] != ob.a[j])
          return 1;
  return 0;
}

Vector Matrix::operator*(const Vector& vt)
{
  if(col != vt.size) {
    cout << "\nThe number of column of matrix <> the size of vector\n";
  }
  Vector mult(row);
  for(int i = 0; i < row; i++)
    for(int j = 0; j < col; j++)
      mult.v[i] += (*a[j]).v[i] * vt.v[j];
  return mult;
}

Matrix Matrix::operator*(const Matrix& b)//   
{
  if(col != b.row)
    throw ("\nThe number of column of first matrix <> "
            "the number of rows the second matrix\n");
  Matrix c(row, b.col);
  for(int i = 0; i < row; i++)
    for(int j = 0; j < b.col; j++)
      (*c.a[j]).v[i] = GetLine(i) * *b.a[j];
  return c;
}

void Matrix::SwapLines(int i, int j)
// i-  j-  
{
  double tmp;
  for(int k = 0; k < col; k++){
    tmp = (*a[k]).v[i];
    (*a[k]).v[i] = (*a[k]).v[j];
    (*a[k]).v[j] = tmp;
  }
}

void Matrix::DivLine(int i, double divisor)
// i-   divisor
{
  if(0 == divisor){
    //MessageBox(NULL, "Division the line by zero", "", MB_OK +MB_ICONEXCLAMATION);
    throw("Division the line by zero");
  }
  for(int j = 0; j < col; j++)
    (*a[j]).v[i]/= divisor;
}

void Matrix::DiffLines(int k, int i, double factor)
//  k-  i- ,   factor
{
  for(int j = 0; j < col; j++)
    (*a[j]).v[k]-= (*a[j]).v[i] * factor;
}

void Matrix::MakeMain(int i)// i-   
{
  SwapLines(i, (*a[i]).NumbMainElement(i));
}

Matrix Matrix::operator~()
{
  int i, imain, k;
  if(row != col)
    throw("The inversion of the rectangle matrix");
  Matrix E(row, row);
  Matrix Tmp(*this);
  for(i = 0; i < row; i++)
    (*E.a[i]).v[i] = 1.0;
  for(i = 0; i < row; i++){
    imain = (*a[i]).NumbMainElement(i);
    SwapLines(i, imain);
    E.SwapLines(i, imain);
    double divisor = (*a[i]).v[i];
    DivLine(i, divisor);
    E.DivLine(i, divisor);
    for(k = 0; k < row; k++){
      if(k == i) continue;
      double factor = (*a[i]).v[k];
      DiffLines(k, i, factor);
      E.DiffLines(k, i, factor);
    }
  }
  *this = Tmp;
  return E;
}

Vector Matrix::GetLine(int i)// i-  
{
  Vector ai(col);
  for(int j =0; j < col; j++)
    ai.v[j] = (*a[j]).v[i];
  return ai;
}