//    
#include <iostream.h>
#include <stdlib.h>
#include <math.h>
#include "Vector.h"
#include <math.h>
Vector::Vector(int r)
{
  size = r;
  v = new double[r];
  for(int i = 0; i < r; i++)
    v[i]=0.0;
}

Vector::Vector(const Vector& ob)
{
  size=ob.size;
  v=new double[size];
  for(int i = 0; i < size; i++)
   v[i] = ob.v[i];
}

ostream& operator<<(ostream& stream,const Vector& ob)
{
  for(int i=0;i<ob.size;i++) {
     stream << ob.v[i];
     stream << endl;
  }
  return stream;
}

istream& operator>>(istream& stream, Vector& ob)
{
  for(int i = 0; i < ob.size; i++){
    stream >> ob.v[i];
}
  return stream;
}

Vector& Vector::operator=(const Vector& ob)
{
  if(this != &ob){
    delete v;
    size=ob.size;
    v=new double[size];
    for(int i=0;i<ob.size;i++)
      v[i]=ob.v[i];
  }
  return *this;
}

Vector Vector::operator+(const Vector& ob)
{
  if(size!=ob.size) {
    cout << "\a Sizes of vectors must be identicals!\n";
    exit(1);
  }

  Vector sum(size);

  for(int i=0;i<size;i++) sum.v[i]=v[i]+ob.v[i];

  return sum;
}

Vector Vector::operator-(const Vector& ob)
{
  if(size!=ob.size) {
    cout << "\a Sizes of vectors sizeust be identicals!\n";
    exit(1);
  }

  Vector div(size);

  for(int i=0;i<size;i++) div.v[i]=v[i]-ob.v[i];

  return div;
}

Vector& Vector::operator*(const double d)
{
  for(int i = 0; i < size; i++)
    v[i]*=d;

  return *this;
}

Vector& Vector::operator-()
{
  for(int i=0;i<size;i++) v[i]*=(-1);

  return *this;
}

int Vector::operator==(const Vector& ob)const
{
  if(size!=ob.size) return 0;

  for(int i=0;i<size;i++)
    if(v[i]!=ob.v[i]) return 0;

  return 1;
}

int Vector::operator!=(const Vector& ob)const
{
  if(size!=ob.size) return 1;

  for(int i=0;i<size;i++)
    if(v[i]!=ob.v[i]) return 1;

  return 0;
}

double Vector::operator*(const Vector& ob)const
{
  double tmp=0.0;
  for(int i = 0; i < size; i++)
    tmp+= v[i] * ob.v[i];
  return tmp;
}

double Vector::norma()const
{
  return sqrt((*this)*(*this));
}

double V_cos(const Vector& ob1,const Vector& ob2)
{
  return(ob1*ob2/(ob1.norma()*ob2.norma()));
}

int Vector::NumbMainElement(int i)

//     ,

//      i

{
  double MainEl = fabs(v[i]);
  int NumbMain = i;
  for(int k = i + 1; k < size; k++)
    if(MainEl < fabs(v[k])){
      MainEl = fabs(v[k]);
      NumbMain = k;
    }
  return NumbMain;
}